#!/bin/bash

PREFIX_ORIGINAL=/opt/squeak-3.9-8
PREFIX_EXUPERY=/opt/squeak-3.9-8-exupery

# start fresh
#rm -rf $PREFIX_ORIGINAL $PREFIX_EXUPERY Squeak-3.9-8-original Squeak-3.9-8 Squeak-3.9-5 Squeak-3 exuperyVMFiles src

if [ ! -d ~/downloads ]
then
	mkdir ~/downloads
fi

(
cd ~/downloads
for url in								\
	http://squeakvm.org/unix/release/Squeak-3.9-8.src.tar.gz	\
	http://squeakvm.org/unix/release/Squeak-3.9a-7024.image.tar.gz	\
	http://squeakvm.org/unix/release/Squeak-3.sources.tar.gz	\
	http://www.kampjes.demon.co.uk/vms/exuperyVMFiles.tz		\
	http://www.saltypickle.com/Home/uploads/squeakinstaller-jrp.10.cs
do
	if [ -f `basename $url` ]
	then
		echo "Not re-downloading $url..."
	else
		wget $url
	fi
done
)

# Build a vanilla VM
tar zxf ~/downloads/Squeak-3.9-8.src.tar.gz
tar zxf ~/downloads/Squeak-3.9a-7024.image.tar.gz
tar zxf ~/downloads/Squeak-3.sources.tar.gz
tar zxf ~/downloads/exuperyVMFiles.tz

mv Squeak-3.9-8 Squeak-3.9-8-original
(
	mkdir Squeak-3.9-8-original/bld
	cd Squeak-3.9-8-original/bld
	../platforms/unix/config/configure --prefix=$PREFIX_ORIGINAL
	make
	make install
)
mv Squeak-3.9-5/usr/local/lib/squeak/* $PREFIX_ORIGINAL/lib/squeak
mv Squeak-3.9-5/usr/local/bin/inisqueak $PREFIX_ORIGINAL/bin
mv Squeak-3/usr/local/lib/squeak/SqueakV3.sources $PREFIX_ORIGINAL/lib/squeak/3.9-8

# Now use the vanilla VM build a VM which includes Exupery
tar zxf ~/downloads/Squeak-3.9-8.src.tar.gz
tar zxf ~/downloads/Squeak-3.9a-7024.image.tar.gz
tar zxf ~/downloads/Squeak-3.sources.tar.gz
tar zxf ~/downloads/exuperyVMFiles.tz

gzip -dc Squeak-3.9-5/usr/local/lib/squeak/Squeak3.9a-7024.image.gz > Squeak3.9a-7024.image
gzip -dc Squeak-3.9-5/usr/local/lib/squeak/Squeak3.9a-7024.changes.gz > Squeak3.9a-7024.changes
ln -fs $PREFIX_ORIGINAL/lib/squeak/3.9-8/SqueakV3.sources .

mkdir -p Squeak-3.9-8/platforms/Cross/plugins/ExuperyPlugin
cp exuperyVMFiles/ExuperyPlugin.h Squeak-3.9-8/platforms/Cross/plugins/ExuperyPlugin

mkdir -p Squeak-3.9-8/platforms/unix/plugins/ExuperyPlugin
cp exuperyVMFiles/sqUnixExuperyPlugin.c Squeak-3.9-8/platforms/unix/plugins/ExuperyPlugin

cp Squeak-3.9-8/platforms/unix/plugins/JPEGReadWriter2Plugin/Makefile.inc Squeak-3.9-8/platforms/unix/plugins/ExuperyPlugin

cat << EOF | sed -e 's/$/\r/' > runVMM.st
(FileStream fileNamed: '$HOME/downloads/squeakinstaller-jrp.10.cs') fileIn.

installer := SqueakInstaller new.

installer publicMczs: {
	{ 'VMMaker'.  'http://www.squeaksource.com/Exupery'. 'VMMaker-wbk.63.mcz' }.
	{ 'Exupery'.  'http://www.squeaksource.com/Exupery'. 'Exupery-wbk.233.mcz' }.
}.
installer messagesToSuppress: #().
installer autoAnswers: #().
installer install.

installer := nil.

vmm := VMMaker default.
vmm platformRootDirectoryName: '$PWD/Squeak-3.9-8/platforms';
	sourceDirectoryName: '$PWD/src'.
vmm initializeAllInternalBut: #(UUIDPlugin B3DAcceleratorPlugin).
vmm generateEntire.
vmm := nil.

Smalltalk garbageCollect.
SmalltalkImage current snapshot: true andQuit: true.
EOF

# Run the original VM to generate the Exupery plugin code
$PREFIX_ORIGINAL/bin/squeak Squeak3.9a-7024.image $PWD/runVMM.st

# Now compile and install the Exupery VM
(
	mkdir Squeak-3.9-8/bld
	cd Squeak-3.9-8/bld
	../platforms/unix/config/configure --prefix=$PREFIX_EXUPERY --with-src=../src
	make
	make install
)
mv Squeak-3.9-5/usr/local/lib/squeak/* $PREFIX_EXUPERY/lib/squeak
mv Squeak-3.9-5/usr/local/bin/inisqueak $PREFIX_EXUPERY/bin
mv Squeak-3/usr/local/lib/squeak/SqueakV3.sources $PREFIX_EXUPERY/lib/squeak/3.9-8

# at this point you can run:
#$PREFIX_EXUPERY/bin/squeak Squeak3.9a-7024.image

